#include	"compiler.h"
#include	<ddraw.h>
#include	"dd2.h"
#include	"dd2sub.h"


void DD2SUBF dd2sub8_forebit1(const DD2_VRAM *vram, const void *data,
										const DWORD x, const DWORD y,
										const DWORD fg) {

	BYTE	*s;
	BYTE	*p;
	BYTE	*q;
	BYTE	c;
	BYTE	bit;
	BYTE	sx, sy;

	s = (BYTE *)data;
	p = (BYTE *)data;
	p += 2;
	q = vram->ptr;
	q += vram->align * y;
	q += x;

	sy = s[1];
	do {
		BYTE *r;
		r = q;
		sx = s[0];
		bit = 0;
		c = 0;
		do {
			if (!bit) {
				bit = 0x80;
				c = *p++;
			}
			if (c & bit) {
				*r = (BYTE)fg;
			}
			bit >>= 1;
			r++;
		} while(--sx);
		q += vram->align;
	} while(--sy);
}

void DD2SUBF dd2sub16_forebit1(const DD2_VRAM *vram, const void *data,
										const DWORD x, const DWORD y,
										const DWORD fg) {

	BYTE	*s;
	BYTE	*p;
	BYTE	*q;
	BYTE	c;
	BYTE	bit;
	BYTE	sx, sy;

	s = (BYTE *)data;
	p = (BYTE *)data;
	p += 2;
	q = vram->ptr;
	q += vram->align * y;
	q += x * 2;

	sy = s[1];
	do {
		WORD *r;
		r = (WORD *)q;
		sx = s[0];
		bit = 0;
		c = 0;
		do {
			if (!bit) {
				bit = 0x80;
				c = *p++;
			}
			if (c & bit) {
				*r = (WORD)fg;
			}
			bit >>= 1;
			r++;
		} while(--sx);
		q += vram->align;
	} while(--sy);
}

void DD2SUBF dd2sub24_forebit1(const DD2_VRAM *vram, const void *data,
										const DWORD x, const DWORD y,
										const DWORD fg) {

	BYTE	*s;
	BYTE	*p;
	BYTE	*q;
	BYTE	c;
	BYTE	bit;
	BYTE	sx, sy;

	s = (BYTE *)data;
	p = (BYTE *)data;
	p += 2;
	q = vram->ptr;
	q += vram->align * y;
	q += x * 3;

	sy = s[1];
	do {
		BYTE *r;
		r = q;
		sx = s[0];
		bit = 0;
		c = 0;
		do {
			if (!bit) {
				bit = 0x80;
				c = *p++;
			}
			if (c & bit) {
				r[0] = ((BYTE *)&fg)[0];
				r[1] = ((BYTE *)&fg)[1];
				r[2] = ((BYTE *)&fg)[2];
			}
			bit >>= 1;
			r += 3;
		} while(--sx);
		q += vram->align;
	} while(--sy);
}

void DD2SUBF dd2sub32_forebit1(const DD2_VRAM *vram, const void *data,
										const DWORD x, const DWORD y,
										const DWORD fg) {

	BYTE	*s;
	BYTE	*p;
	BYTE	*q;
	BYTE	c;
	BYTE	bit;
	BYTE	sx, sy;

	s = (BYTE *)data;
	p = (BYTE *)data;
	p += 2;
	q = vram->ptr;
	q += vram->align * y;
	q += x * 4;

	sy = s[1];
	do {
		DWORD *r;
		r = (DWORD *)q;
		sx = s[0];
		bit = 0;
		c = 0;
		do {
			if (!bit) {
				bit = 0x80;
				c = *p++;
			}
			if (c & bit) {
				*r = fg;
			}
			bit >>= 1;
			r++;
		} while(--sx);
		q += vram->align;
	} while(--sy);
}


// ----

void DD2SUBF dd2sub8_putbit1(const DD2_VRAM *vram, const void *data,
										const DWORD x, const DWORD y,
										const DWORD bg, const DWORD fg) {

	BYTE	*s;
	BYTE	*p;
	BYTE	*q;
	BYTE	c;
	BYTE	bit;
	BYTE	sx, sy;

	s = (BYTE *)data;
	p = (BYTE *)data;
	p += 2;
	q = vram->ptr;
	q += vram->align * y;
	q += x;

	sy = s[1];
	do {
		BYTE *r;
		r = q;
		sx = s[0];
		bit = 0;
		c = 0;
		do {
			if (!bit) {
				bit = 0x80;
				c = *p++;
			}
			if (c & bit) {
				*r = (BYTE)fg;
			}
			else {
				*r = (BYTE)bg;
			}
			bit >>= 1;
			r++;
		} while(--sx);
		q += vram->align;
	} while(--sy);
}

void DD2SUBF dd2sub16_putbit1(const DD2_VRAM *vram, const void *data,
										const DWORD x, const DWORD y,
										const DWORD bg, const DWORD fg) {

	BYTE	*s;
	BYTE	*p;
	BYTE	*q;
	BYTE	c;
	BYTE	bit;
	BYTE	sx, sy;

	s = (BYTE *)data;
	p = (BYTE *)data;
	p += 2;
	q = vram->ptr;
	q += vram->align * y;
	q += x * 2;

	sy = s[1];
	do {
		WORD *r;
		r = (WORD *)q;
		sx = s[0];
		bit = 0;
		c = 0;
		do {
			if (!bit) {
				bit = 0x80;
				c = *p++;
			}
			if (c & bit) {
				*r = (WORD)fg;
			}
			else {
				*r = (WORD)bg;
			}
			bit >>= 1;
			r++;
		} while(--sx);
		q += vram->align;
	} while(--sy);
}

void DD2SUBF dd2sub24_putbit1(const DD2_VRAM *vram, const void *data,
										const DWORD x, const DWORD y,
										const DWORD bg, const DWORD fg) {

	BYTE	*s;
	BYTE	*p;
	BYTE	*q;
	BYTE	c;
	BYTE	bit;
	BYTE	sx, sy;

	s = (BYTE *)data;
	p = (BYTE *)data;
	p += 2;
	q = vram->ptr;
	q += vram->align * y;
	q += x * 3;

	sy = s[1];
	do {
		BYTE *r;
		r = q;
		sx = s[0];
		bit = 0;
		c = 0;
		do {
			if (!bit) {
				bit = 0x80;
				c = *p++;
			}
			if (c & bit) {
				r[0] = ((BYTE *)&fg)[0];
				r[1] = ((BYTE *)&fg)[1];
				r[2] = ((BYTE *)&fg)[2];
			}
			else {
				r[0] = ((BYTE *)&bg)[0];
				r[1] = ((BYTE *)&bg)[1];
				r[2] = ((BYTE *)&bg)[2];
			}
			bit >>= 1;
			r += 3;
		} while(--sx);
		q += vram->align;
	} while(--sy);
}

void DD2SUBF dd2sub32_putbit1(const DD2_VRAM *vram, const void *data,
										const DWORD x, const DWORD y,
										const DWORD bg, const DWORD fg) {

	BYTE	*s;
	BYTE	*p;
	BYTE	*q;
	BYTE	c;
	BYTE	bit;
	BYTE	sx, sy;

	s = (BYTE *)data;
	p = (BYTE *)data;
	p += 2;
	q = vram->ptr;
	q += vram->align * y;
	q += x * 4;

	sy = s[1];
	do {
		DWORD *r;
		r = (DWORD *)q;
		sx = s[0];
		bit = 0;
		c = 0;
		do {
			if (!bit) {
				bit = 0x80;
				c = *p++;
			}
			if (c & bit) {
				*r = fg;
			}
			else {
				*r = bg;
			}
			bit >>= 1;
			r++;
		} while(--sx);
		q += vram->align;
	} while(--sy);
}

